/* Alg lui Dijkstra
 * Complexitate: O(n^2)
 * Det distanta minima de la un nod ales drept sursa
 * la celelalte noduri din graf.
 * 
 */ 
#include <fstream>
#include <vector>
#include <queue>
using namespace std;

ifstream fin("dijkstra.in");
ofstream fout("dijkstra.out");

const int N = 1001, Inf = 0x3f3f3f3f;
int c[N][N]; // matricea ponderilor muchiilor 
int d[N];    // d[x] = dist minima de la nodul sursa S la nodul x  
bool s[N];   // selectam nodurile ajunse la dist minima
int n;

void ReadGraph();
void Dijkstra(int x, int d[]); // x = nodul sursas
void WriteDist(int d[]);

int main()
{
	ReadGraph();
	Dijkstra(1, d);
	WriteDist(d);
	
	return 0;
}

void Dijkstra(int x, int d[]) // x = nodul sursa
{
	s[x] = true;
	// initializari pt d[]
	for (int j = 1; j <= n; ++j)
		d[j] = c[x][j];
	
	for (int pas = 1; pas < n; ++pas)
	{
		int dmin = Inf;
		for (int y = 1; y <= n; ++y)
			if (!s[y] && d[y] < dmin)
			{
				x = y;
				dmin = d[y];
			}
		s[x] = true;
		
		for (int y = 1; y <= n; ++y)
			if (d[y] > d[x] + c[x][y])
				d[y] = d[x] + c[x][y];
	}
}


void WriteDist(int d[])
{
	for (int i = 1; i <= n; ++i)
		if (d[i] != Inf)
			fout << d[i] << ' ';
		else
			fout << " oo";
}

void ReadGraph()
{
	fin >> n;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j)
			if (i != j)
				c[i][j] = Inf;
	
	int x, y, w;
	while (fin >> x >> y >> w)
		c[x][y] = c[y][x] = w;
}


