#include <fstream>
#include <vector>
#include <algorithm>
#include <queue>
#include <tuple>
using namespace std;

ifstream fin("catun.in");
ofstream fout("catun.out");

const int Inf = 0x3f3f3f3f;
using VB  = vector<bool>;
using VI  = vector<int>;
using PI  = pair<int, int>;
using VP  = vector<PI>;
using VVP = vector<VP>;

priority_queue<PI, vector<PI>, greater<PI>> Q;
VVP G;
VI d;
VB este_fort;
VI fortarete;
VI fa;     /// fa[x] = fortareata de care apartine nodul x
int n, m, K;

void ReadGraph();
void Dijkstra(VI& d); 
void WriteSol(VI& d);

int main()
{
	ReadGraph();
	Dijkstra(d);
	
	WriteSol(d);
	
	return 0;
}

void Dijkstra(VI& d) // O(n * log2(m))
{
	d = VI(n + 1, Inf);
	for (int f : fortarete)  // nodurile sursa = fortaretele
	{
		d[f] = 0;
		Q.emplace(0, f);
	}
		
	while (!Q.empty())
	{
		auto [dx, x] = Q.top();
		Q.pop();
		
		if (dx > d[x]) // daca x iese din coada pentru a doua oara
			continue;
		
		for (auto [y, w] : G[x])
		{
			if (d[y] > d[x] + w)
			{
				d[y] = d[x] + w;
				fa[y] = fa[x];
				Q.emplace(d[y], y);
			}
			else 
			if (d[y] == d[x] + w && fa[x] < fa[y])
			{
				fa[y] = fa[x];
			}
		}	
	}
}

void WriteSol(VI& d)
{
	for (int i = 1; i <= n; ++i)
		if (este_fort[i] || d[i] == Inf)
			fout << 0 << ' ';
		else
			fout << fa[i] << ' ';
}

void ReadGraph()
{
	fin >> n >> m >> K;
	este_fort = VB(n + 1);
	G = VVP(n + 1); // G[0], G[1]
	fa = VI(n + 1);
	
	int f;
	for (int i = 1; i <= K; ++i)
	{
		fin >> f;
		fortarete.push_back(f);
		este_fort[f] = true;
		fa[f] = f;
	}
	
	int x, y, w;
	while (m--)
	{
		fin >> x >> y >> w;	
		G[x].emplace_back(y, w);
		G[y].emplace_back(x, w);
	}
}

