#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <queue>
#include <tuple>
using namespace std;



ifstream fin("9-lanturi.in");
ofstream fout("lanturi.out");

const int Inf = 0x3f3f3f3f;
using VB  = vector<bool>;
using VI  = vector<int>;
using PI  = pair<int, int>;
using VP  = vector<PI>;
using VVP = vector<VP>;
using VLL = vector<uint64_t>; // unsigned long long

VVP G;
VI d;
VLL nr;    //  nr[x] = nr de lanturi de lungime minima de la sursa S la nodul x
int n, m;
int S, D; // nodul sursa / destinatie

void ReadGraph();
void Dijkstra(int x, VI& d); // x = nodul sursa

int main()
{
	ReadGraph();
	Dijkstra(S, d);
	
	fout << nr[D];
	
	return 0;
}

void Dijkstra(int x, VI& d) // O(n * log2(m))
{
	priority_queue<PI, vector<PI>, greater<PI>> Q;
	d = VI(n + 1, Inf);
	
	nr[x] = 1; // obligatoriu!
	d[x] = 0;
	Q.emplace(0, x);
		
	while (!Q.empty())
	{
		auto [dx, x] = Q.top();
		Q.pop();
		
		if (dx > d[x]) // daca x iese din coada pentru a doua oara
			continue;
		
		for (auto p : G[x])
		{
			auto [y, w] = p;
			if (d[y] > d[x] + w)
			{
				d[y] = d[x] + w;
				nr[y] = nr[x];
				Q.emplace(d[y], y);
			}
			else 
			if (d[y] == d[x] + w)
			{
				nr[y] += nr[x];
			}
		}	
	}
}

void ReadGraph()
{
	fin >> n >> m >> S >> D;
	G = VVP(n + 10); // G[0], G[1]
	nr = VLL(n + 10);
	int x, y, w;
	while (m--)
	{
		fin >> x >> y >> w;
		
		G[x].emplace_back(y, w);
		G[y].emplace_back(x, w);
	}
}

