#include <iostream>
#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("maxq.in");
ofstream fout("maxq.out");


const int DIM = 200001;

int n, m, op, a, b, A[DIM];
long long ans;  // suma maxima a unei secvente
long long sum;  // suma secventei curente

// maxim, left, right, total pe interval
long long M[4 * DIM], L[4 * DIM], R[4 * DIM], S[4 * DIM];

void Build(int x, int l, int r);
void Update(int x, int l, int r);
void Query(int x, int l, int r);

int main()
{
    fin >> n;
    for ( int i = 1; i <= n; i++ )
        fin >> A[i];
    fin >> m;
    Build(1, 1, n);
    while ( m )
    {
        m--;
        fin >> op >> a >> b;
        if ( op == 0 )
        {
            a++;  // a - pozitie in sirul A[]
            Update(1, 1, n);
        }
        else
        {
            sum = ans = 0;
            a++;
            b++;
            Query(1, 1, n);
            fout << ans << '\n';
        }
    }
    fin.close();
    fout.close();
    return 0;
}

void Build(int x, int l, int r)
{
    if (l == r)
    {
        S[x] = A[l];      // totalul ramane asa
        M[x] = L[x] = R[x] = max(A[l], 0); // dar maximele nu accepta negativ
        return;
    }
    int m = (l + r) / 2;
    Build(2 * x, l, m);
    Build(2 * x + 1, m + 1, r);

    S[x] = S[2 * x] + S[2 * x + 1];
    L[x] = max(L[2 * x], S[2 * x] + L[2 * x + 1]);
    R[x] = max(R[2 * x + 1], R[2 * x] + S[2 * x + 1]);
    M[x] = max({M[2 * x + 1], M[2 * x], R[2 * x] + L[2 * x + 1]});
}

void Update(int x, int l, int r)
{
    if (l == r)
    {
        S[x] = b;  // totalul pe interval
        M[x] = L[x] = R[x] = max(b, 0);
        return;
    }

    int m = (l + r) / 2;
    if (a <= m)
        Update(2 * x, l, m);
    else
        Update(2 * x + 1, m + 1, r);

    S[x] = S[2 * x] + S[2 * x + 1];                        // suma totala pe interval
    L[x] = max(L[2 * x], S[2 * x] + L[2 * x + 1]);         // stanga
    R[x] = max(R[2 * x + 1], R[2 * x] + S[2 * x + 1]);     // dreapta
    M[x] = max({M[2 * x + 1], M[2 * x], R[2 * x] + L[2 * x + 1]});  // maximul
}

void Query(int x, int l, int r)
{
    if (a <= l && r <= b)
    {
		if (sum < 0)   // daca suma secventei curente este negativa, renuntam la secventa curenta
            sum = 0;
		ans = max(ans, max(sum + L[x], M[x]));  // culegem maximul pana in acest moment

        sum = max(sum + S[x], R[x]);  // prelungim secventa curenta, sau incepem o secventa noua cu R[x]
        return;
	}

    int m = (l + r) / 2;
	if (a <= m)
		Query(2 * x, l, m);
	if ( b > m)
		Query(2 * x + 1, m + 1, r);
}
